import { Model, Query } from '@vuex-orm/core';
import Components from './contracts/Components';
import Config from './contracts/Config';
import Options from './contracts/Options';
import * as Store from './contracts/Store';
export default class VuexORMSoftDelete {
    /**
     * The Model component.
     */
    model: typeof Model;
    /**
     * The Query component.
     */
    query: typeof Query;
    /**
     * The store action tree.
     */
    actions: Store.Actions;
    /**
     * The store getters tree.
     */
    getters: Store.Getters;
    /**
     * The store root getters tree.
     */
    rootGetters: Store.RootGetters;
    /**
     * The store root action tree.
     */
    rootActions: Store.RootActions;
    /**
     * The global configuration object.
     */
    config: Config;
    /**
     * Create a new plugin instance.
     */
    constructor(components: Components, config: Options);
    /**
     * Create a new config by merging with global user-defined config.
     * Allows for generating local configs such as on a per-model basis.
     */
    createConfig(config?: Options): Config;
    /**
     * Plugin features.
     */
    plugin(): void;
}
