import { __assign } from "tslib";
import ModelMixin from './mixins/Model';
import QueryMixin from './mixins/Query';
import ActionsMixin from './mixins/Actions';
import GettersMixin from './mixins/Getters';
import RootActionsMixin from './mixins/RootActions';
import RootGettersMixin from './mixins/RootGetters';
import GlobalConfig from './config/GlobalConfig';
var VuexORMSoftDelete = /** @class */ (function () {
    /**
     * Create a new plugin instance.
     */
    function VuexORMSoftDelete(components, config) {
        this.model = components.Model;
        this.query = components.Query;
        this.actions = components.Actions;
        this.getters = components.Getters;
        this.rootActions = components.RootActions;
        this.rootGetters = components.RootGetters;
        this.config = this.createConfig(config);
    }
    /**
     * Create a new config by merging with global user-defined config.
     * Allows for generating local configs such as on a per-model basis.
     */
    VuexORMSoftDelete.prototype.createConfig = function (config) {
        return __assign(__assign(__assign({}, GlobalConfig), this.config), config);
    };
    /**
     * Plugin features.
     */
    VuexORMSoftDelete.prototype.plugin = function () {
        ModelMixin(this, this.model);
        QueryMixin(this, this.query);
        ActionsMixin(this, this.actions);
        GettersMixin(this, this.getters);
        RootActionsMixin(this, this.rootActions);
        RootGettersMixin(this, this.rootGetters);
    };
    return VuexORMSoftDelete;
}());
export default VuexORMSoftDelete;
//# sourceMappingURL=VuexORMSoftDelete.js.map